﻿using System;
using System.Linq;
using System.Windows.Controls;
using Telerik.Windows.DragDrop;
using System.Windows;
using System.Windows.Input;
using System.Collections;
using Telerik.Windows.Controls;

namespace RadTreeViewApp1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            DragDropManager.AddDragInitializeHandler(xTreeView, OnDragInitialize);
            DragDropManager.AddGiveFeedbackHandler(xTreeView, OnGiveFeedback);
            DragDropManager.AddDragDropCompletedHandler(xTreeView, OnDragCompleted);
            DragDropManager.AddDropHandler(xTreeView, OnDrop, true);
        }

        private void OnDragInitialize(object sender, DragInitializeEventArgs args)
        {
            args.AllowedEffects = DragDropEffects.All;
            var payload = DragDropPayloadManager.GeneratePayload(null);
            args.Data = ((FrameworkElement)args.OriginalSource).DataContext;
            args.DragVisual = new ContentControl { Content = args.Data, ContentTemplate = this.Resources["DraggedItemTemplate"] as DataTemplate };
        }

        private void OnGiveFeedback(object sender, Telerik.Windows.DragDrop.GiveFeedbackEventArgs args)
        {
            args.SetCursor(Cursors.Arrow);
            args.Handled = true;
        }

        private void OnDrop(object sender, Telerik.Windows.DragDrop.DragEventArgs args)
        {
            if ((args.Source as FrameworkElement).ParentOfType<RadTreeViewItem>() != null)
            {
                RadTreeViewItem treeItem = (args.Source as FrameworkElement).ParentOfType<RadTreeViewItem>();
                ((IList)treeItem.ItemsSource).Add(args.Data);
            }
            else
                ((IList)(sender as RadTreeView).ItemsSource).Add(args.Data);
        }

        public void OnDragCompleted(object sender, Telerik.Windows.DragDrop.DragDropCompletedEventArgs args)
        {
           
            if ((args.Source as FrameworkElement).ParentOfType<RadTreeViewItem>() != null)
            {
                RadTreeViewItem treeItem = (args.Source as FrameworkElement).ParentOfType<RadTreeViewItem>();
                ((IList)treeItem.ItemsSource).Remove(args.Data);
            }
            else
                ((IList)(sender as RadTreeView).ItemsSource).Remove(args.Data);
        }
    }
}
