﻿using System;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;

namespace RadTreeViewApp1.ViewModels
{
    public class DataItem : ViewModelBase
    {
        private bool _selected;
        private bool _expanded;

        public DataItem()
        {
            Children = new ObservableCollection<DataItem>();
        }

        public string Header { get; set; }
        public ObservableCollection<DataItem> Children { get; set; }
        public bool Selected
        {
            get
            {
                return this._selected;
            }
            set
            {
                if (this._selected != value)
                {
                    this._selected = value;
                    OnPropertyChanged("Selected");
                }
            }
        }
        public bool Expanded
        {
            get
            {
                return this._expanded;
            }
            set
            {
                if (this._expanded != value)
                {
                    this._expanded = value;
                    OnPropertyChanged("Expanded");
                }
            }
        }
    }
}
